--Main frame for addon
local UIConfig = CreateFrame("Frame", "Death_Roll_Frame", UIParent, "BasicFrameTemplateWithInset");
UIConfig:SetSize(200,250)
UIConfig:SetPoint("CENTER", UIParent, "CENTER")
UIConfig:SetMovable(true)
UIConfig:EnableMouse(true)
UIConfig:RegisterForDrag("LeftButton")
UIConfig:SetScript("OnDragStart", UIConfig.StartMoving)
UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing)

-------------------------------------------------------------------
--Extra frames inside main frame
UIConfig.title = UIConfig:CreateFontString(nil, "OVERLAY");
UIConfig.title:SetFontObject("GameFontHighlight");
UIConfig.title:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, 0);
UIConfig.title:SetText("Death Roll");

--Buttons
--Roll
UIConfig.showButton = CreateFrame("Button", "MyButton", UIConfig, "GameMenuButtonTemplate");
UIConfig.showButton:SetPoint("CENTER", UIConfig, "TOP", -47, -43);
UIConfig.showButton:SetSize(90, 30);
UIConfig.showButton:SetText("Roll");
UIConfig.showButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.showButton:SetHighlightFontObject("GameFontHighlightLarge");
--Restart
UIConfig.delButton = CreateFrame("Button", "MyDelButton", UIConfig, "GameMenuButtonTemplate");
UIConfig.delButton:SetPoint("CENTER", UIConfig, "TOP", 45, -43);
UIConfig.delButton:SetSize(90, 30);
UIConfig.delButton:SetText("Restart");
UIConfig.delButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.delButton:SetHighlightFontObject("GameFontHighlightLarge");
--Options
--[[
UIConfig.optButton = CreateFrame("Button", "MyDelButton", UIConfig, "GameMenuButtonTemplate");
UIConfig.optButton:SetPoint("TOP", UIConfig, "TOP", 34, 0);
UIConfig.optButton:SetSize(60, 20);
UIConfig.optButton:SetText("Options");
UIConfig.optButton:SetNormalFontObject("GameFontNormalSmall");
UIConfig.optButton:SetHighlightFontObject("GameFontHighlightSmall");
]]

--Extra frame for showing result with Scroll frame
--frame for scrollframe and everything that handles with it
local frame = CreateFrame("Frame", "MyFrame", UIConfig) 
frame:SetSize(180, 185) 
frame:SetPoint("CENTER", UIConfig, "CENTER", 0, -25)
local texture=frame:CreateTexture()
texture:SetAllPoints()
texture:SetTexture(0,0,0,0)
UIConfig.frame=frame

--scrollframe: frame that enables the use of scrolling
scrollframe = CreateFrame("ScrollFrame", nil, frame, "FauxScrollFrameTemplate")
scrollframe:SetPoint("CENTER", frame, "CENTER")
frame.scrollframe=scrollframe

--scrollbar
scrollbar = CreateFrame("Slider", nil, scrollframe, "UIPanelScrollBarTemplate")
scrollbar:SetPoint("TOPLEFT", frame, "TOPRIGHT", -15, -17)
scrollbar:SetPoint("BOTTOMLEFT", frame, "BOTTOMRIGHT", -15, 15)
scrollbar:SetMinMaxValues(1,300)
scrollbar:SetValueStep(1)
scrollbar.scrollStep=1
scrollbar:SetValue(0)
scrollbar:SetWidth(15)
scrollbar:SetScript("OnValueChanged", function(self, value)
	self:GetParent():SetVerticalScroll(value)
end)
local scrollbg=scrollbar:CreateTexture(nil, "BACKGROUND")
scrollbg:SetAllPoints(scrollbar)
scrollbg:SetTexture(0,0,0,1)
frame.scrollbar=scrollbar

--contentframe
content = CreateFrame("Frame", nil, scrollframe)
content:SetPoint("CENTER")
local texture=frame:CreateTexture()
texture:SetAllPoints()
texture:SetTexture(0,0,0,0)
content.texture=texture
content:SetWidth(175)
content:SetHeight(200)
scrollframe.content=content

scrollframe:SetScrollChild(content)

-----------------------------------------------------------------------
--Code
local clickAmount = 0
local upperLimit = 9999
local lowerLimit = 1
local temp = 0
--local textToShow = ""
UIConfig.delButton:Disable()

local function roll(upNum)
	temp = math.random(1, upNum)
	if temp == lowerLimit then
		return tostring(temp) .. " (" .. tostring(lowerLimit) .. "-" .. tostring(upNum) .. ") " .. UnitName("player") .. " has WON the game!"
	else
		return tostring(temp) .. " (" .. tostring(lowerLimit) .. "-" .. tostring(upNum) .. ")"
	end
end


UIConfig.showButton:SetScript("OnClick", function(self)
	clickAmount = clickAmount + 1
	frame.show = frame:CreateFontString(nil, "BORDER");
	frame.show:SetFontObject("GameFontHighlight");
	frame.show:SetPoint("Left", frame, "TOP", -88, (10 - (clickAmount * 20)));
	frame.show:SetJustifyH("LEFT")
	frame.show:SetSize(160, 200)
	frame.show:SetWordWrap(true)
	if clickAmount==1 then
		frame.show:SetText(roll(upperLimit));
	else
		frame.show:SetText(roll(temp));
	end
	--UIConfig.textFrame.show:SetText(textToShow);
	if temp==lowerLimit then
		UIConfig.showButton:Disable()
		UIConfig.delButton:Enable()
	end
end);

UIConfig.delButton:SetScript("OnClick", function(self)
	UIConfig.showButton:Enable()
	temp = 0
	textToShow = ""
	frame.show:SetText(textToShow);
	clickAmount = 0
	UIConfig.delButton:Disable()
end)
